(* File lexer.mll *)
{
  open Parser        (* The type token is defined in parser.mli *)
  exception Eof
}
let small = ['a'-'z']
let cap = ['A'-'Z']
let ident_num = ['a'-'z' 'A'-'Z' '0'-'9']
rule token = parse
    [' ' '\t']      { token lexbuf }     (* skip blanks *)
  | '\\' '\n'       { token lexbuf }
  | '.'             { raise Eof }
  | '\n'            { EOL }
  | small ident_num* as w { CONST w }
  | cap ident_num* as w { VAR w }
  | '-' '>'         { REWR }
  | ','             { COMMA }
  | '('             { LPAR }
  | ')'             { RPAR }
  | eof             { raise Eof }
