open Parser
open Format
open List
open Tree
open Rewrite

let test = function
  | [] -> print_flush ()
  | pairs  -> 
    let print_rewr = 
      iter (fun (a,b) ->
        printf "  "; print_term a; printf " -> "; print_term b; printf "\n")
    and print_rpo s aux =
      iter (fun (a,b) ->
        printf "  ";
        print_term a;
        printf " >_%s " s;
        print_term b;
        printf " ? ";
        print_bool (aux strict b a);
        printf "\n")
    in
    printf "Rewrites:\n";
    print_rewr pairs;
    printf "lpo:\n";
    print_rpo "lpo" lpo pairs;
    printf "mpo:\n";
    print_rpo "mpo" mpo pairs;
    printf "\n";
    print_flush ()

let _ =
  try
    let lexbuf = Lexing.from_channel stdin in
    while true do
      let pairs = Parser.main Lexer.token lexbuf in
      test pairs
    done
  with Lexer.Eof ->
    exit 0
