/* File parser.mly */
%token <string> CONST
%token <string> VAR
%token COMMA REWR
%token LPAR RPAR
%token EOL
%start main             /* the entry point */
%type <Tree.unif list> main
%%
main:
    unifs EOL                   { $1 }
;
unifs:
    /* empty */                 { [] }
  | unifs term REWR term        { ($2, $4)::$1 }
;
term:
  | VAR                         { Tree.term_of_varname $1 }
  | CONST                       { Tree.term_of_funname $1 [] }
  | CONST LPAR RPAR             { Tree.term_of_funname $1 [] }
  | CONST LPAR termlist RPAR    { Tree.term_of_funname $1 $3 }
;
termlist:
    term                        { [$1] }
  | term COMMA termlist         { $1::$3 }
;
