open Tree
open List

(* An OCaml linear ordering is a function 'a -> 'a -> int that returns
   0 if the two arguments are equal, a negative number if in
   increasing order, and a positive number otherwise. *)
type 'a lo = 'a -> 'a -> int

(* A strict partial ordering rather returns a boolean value, telling
   whether the first argument is smaller than the second. *)
type 'a spo = 'a -> 'a -> bool

(* Return the OCaml strict ordering for a given linear ordering. *)
let strict e e' = (compare e e') < 0

(* The lexicographic ordering generated by o over sequences l and l'.
   val lex : 'a spo -> 'a list spo *)
let rec lex o l l' = (* TODO *)
  
(* val mul : 'a spo -> 'a list spo *)
let mul o l l' = (* TODO *)

(* A status tells for each function symbol which sequence ordering to
   apply; this is called `tau' in the lecture notes. *) 
type 'a status = string * int -> 'a spo -> 'a list spo

(* val rpo : Tree.term status -> (string * int) spo -> Tree.term spo *)
let rec rpo stat o t t' = (* TODO *)

(* `lpo' is simply `rpo' with status `lex' for all the symbols *)
let lpo =
  let aux _ = lex in
  rpo aux

(* `mpo' is simply `rpo' with status `mul' for all the symbols *)
let mpo =
  let aux _ = mul in
  rpo aux

