open Format
open List

type var   = string
type term  = Var of var | Fun of string * term list
type subst = (var * term) list
type unif  = term * term

(* Type constructors *)
let term_of_varname v = Var v

let term_of_funname f l = Fun (f, l)
    
(* Displays the terms on stdout. *)
let print_term = 
  let rec aux s = function
    | Var v
      -> printf "%s%s" s v
    | Fun (f, [])
      -> printf "%s%s" s f
    | Fun (f, h::t) 
      -> printf "%s%s" s f;
        aux "(" h;
        iter (aux ",") t;
        printf ")"
  in aux ""
